.386
.model flat,stdcall
option casemap:none

    include \masm32\include\windows.inc

    include \masm32\include\wsock32.inc
    includelib \masm32\lib\wsock32.lib

    include \masm32\include\user32.inc 
    includelib \masm32\lib\user32.lib   
         
    include \MASM32\INCLUDE\gdi32.inc
    includelib \MASM32\LIB\gdi32.lib
      
    include \MASM32\INCLUDE\Comctl32.inc
    includelib \MASM32\LIB\Comctl32.lib
      
    include \masm32\include\kernel32.inc 
    includelib \masm32\lib\kernel32.lib

    include \masm32\include\masm32.inc
    includelib \masm32\lib\masm32.lib

    include \masm32\include\Vfw.inc
    includelib \masm32\lib\Vfw32.lib

WndProc proto :DWORD,:DWORD,:DWORD,:DWORD
prSaveImage PROTO :DWORD,:DWORD

DEFAULT_QUALITY         EQU     0
DRAFT_QUALITY           EQU     1
PROOF_QUALITY           EQU     2
NONANTIALIASED_QUALITY  EQU     3
ANTIALIASED_QUALITY     EQU     4

DEFAULT_PITCH           EQU     0
FIXED_PITCH             EQU     1
VARIABLE_PITCH          EQU     2
MONO_FONT               EQU     8

; macros:
; CTEXT macro
; eg.
; invoke MessageBox, NULL, CTEXT("Hello World!"), NULL, MB_OK
CTEXT macro y:vararg
    local sym

    const segment
	
    ifidni <y>, <>
        sym db 0
    else
        sym db y, 0
    endif
    const ends
    exitm <offset sym>
endm


DIBSECTION struct DWORD
    dsBm        BITMAP<?>
    dsBmih      BITMAPINFOHEADER<?>
    dsBitfields DWORD 3      DUP (?)
    dshSection      HANDLE  ?
    dsOffset        DWORD   ?
DIBSECTION ENDS

.const

; symbolic equates for the main dialog

.data
    
    ; video capture window
    hWndCap1                    DWORD       0
    hWndCap2                    DWORD       0
    hWndCap3                    DWORD       0
    hComboCapture1              DWORD       0
    hComboCapture2              DWORD       0
    hComboCapture3              DWORD       0
    hBMPFile                    DWORD       0
    hWebcamBitmap               DWORD       0
    hSaveMem                    DWORD       0

    szNone                      db  "None",0

    CapDrvCaps      CAPDRIVERCAPS<>

    pBitmapBits     DWORD       0
    bmi             BITMAPINFO<>
    bmDIBSECTION             DIBSECTION<>
    bmBITMAP             BITMAP<>
    bmfh        BITMAPFILEHEADER<>
    bmih        BITMAPINFOHEADER<>
    
    dwnewindex          dd          0
    
    ; general purpose buffers
    buffer                  db      255 dup (0)
    buffer2                 db      255 dup (0)
    
    ; application specific
    szAppName               db      "Scrontsoft Webcam",0
    hInstance               DWORD   0


; #########################################################################
.code
start:

    invoke GetModuleHandle,0
    mov hInstance,eax

    invoke InitCommonControls

    invoke DialogBoxParam,hInstance,100,0,ADDR WndProc,0

    invoke ExitProcess,0
; #########################################################################

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 
LOCAL rc:RECT
LOCAL l_hWnd:DWORD
LOCAL hDC:DWORD
LOCAL hComDC:DWORD
LOCAL bResult:DWORD


    .if uMsg==WM_INITDIALOG

        ; make a capture window

        ; grab the handles for the comboboxes
        invoke GetDlgItem, hWnd, 144
        mov hComboCapture1, eax
        invoke GetDlgItem, hWnd, 178
        mov hComboCapture2, eax
        invoke GetDlgItem, hWnd, 183
        mov hComboCapture3, eax

        ; place "None" as the first selection so that the user can
        ; switch a camera off if there's a bandwidth problem
        invoke SendMessage, hComboCapture1, CB_ADDSTRING, 0, ADDR szNone
        invoke SendMessage, hComboCapture2, CB_ADDSTRING, 0, ADDR szNone
        invoke SendMessage, hComboCapture3, CB_ADDSTRING, 0, ADDR szNone

        ; loop through all available devices and add them to the comboboxes
        xor ecx, ecx
        @@:
            push ecx
            invoke capGetDriverDescription, ecx, ADDR buffer, \
                    sizeof buffer, ADDR buffer2, sizeof buffer2
	    or eax, eax
	    jz @F
            invoke SendMessage, hComboCapture1, CB_ADDSTRING, 0, ADDR buffer
            invoke SendMessage, hComboCapture2, CB_ADDSTRING, 0, ADDR buffer
            invoke SendMessage, hComboCapture3, CB_ADDSTRING, 0, ADDR buffer
            invoke RtlZeroMemory, ADDR buffer, sizeof buffer ; better to empty them on each loop
            invoke RtlZeroMemory, ADDR buffer2, sizeof buffer2
            pop ecx
            inc ecx
        jmp @B
            push ecx
        @@:
            pop ecx

        ; get a RECT which will fit inside the client area of the static window
        invoke GetDlgItem, hWnd, 141
        mov l_hWnd, eax
        
        invoke GetClientRect, l_hWnd, ADDR rc
        invoke AdjustWindowRect, ADDR rc, SS_ETCHEDFRAME OR SS_SUNKEN, FALSE
        mov eax, rc.right
        sub eax, 4
        mov rc.right, eax
        mov eax, rc.bottom
        sub eax, 4
        mov rc.bottom, eax

        ; create the capture windows
        invoke capCreateCaptureWindow, CTEXT("SSCaptureWindow1"), \
        WS_CHILD OR WS_VISIBLE, 2, 2, rc.right, rc.bottom, l_hWnd, 20
        mov hWndCap1, eax
        
        invoke GetDlgItem, hWnd, 179
        mov l_hWnd, eax
        invoke capCreateCaptureWindow, CTEXT("SSCaptureWindow2"), \
        WS_CHILD OR WS_VISIBLE, 2, 2, rc.right, rc.bottom, l_hWnd, 20
        mov hWndCap2, eax
        
        invoke GetDlgItem, hWnd, 184
        mov l_hWnd, eax
        invoke capCreateCaptureWindow, CTEXT("SSCaptureWindow3"), \
        WS_CHILD OR WS_VISIBLE, 2, 2, rc.right, rc.bottom, l_hWnd, 20
        mov hWndCap3, eax

        invoke SendMessage, hComboCapture1, CB_SETCURSEL, 0, 0
        invoke SendMessage, hComboCapture2, CB_SETCURSEL, 0, 0
        invoke SendMessage, hComboCapture3, CB_SETCURSEL, 0, 0

        xor eax, eax
        ret

;--------------------------------------------------------
;----   WM_CLOSE
    .elseif uMsg == WM_CLOSE
        invoke SendMessage, hWndCap1, WM_CAP_DRIVER_DISCONNECT, 0, 0
        invoke SendMessage, hWndCap2, WM_CAP_DRIVER_DISCONNECT, 0, 0
        invoke SendMessage, hWndCap3, WM_CAP_DRIVER_DISCONNECT, 0, 0
        
        invoke EndDialog, hWnd, 0

        xor eax, eax
        ret

;--------------------------------------------------------
;----   WM_COMMAND
    .elseif uMsg==WM_COMMAND
        mov eax,wParam
        mov edx, eax
        shr edx, 16
        
        .if dx==CBN_SELCHANGE      ; the user has selected/changed the capture device

                mov eax, lParam
                .if eax == hComboCapture1
                    invoke SendMessage, hWndCap1, WM_CAP_DRIVER_DISCONNECT, 0, 0
                    invoke SendMessage, hComboCapture1, CB_GETCURSEL, ADDR dwnewindex, 0
                    .if eax == 0
                        invoke SendMessage, hWndCap1, WM_CAP_DRIVER_DISCONNECT, 0, 0
                        xor eax,eax
                        ret
                    .endif
                    dec eax
                    invoke SendMessage, hWndCap1, WM_CAP_DRIVER_CONNECT, eax, 0
                    invoke SendMessage, hWndCap1, WM_CAP_SET_PREVIEWRATE, 1000, 0
                    invoke SendMessage, hWndCap1, WM_CAP_SET_SCALE, TRUE, 0
                    invoke SendMessage, hWndCap1, WM_CAP_SET_PREVIEW, TRUE, 0
                    
                .elseif eax == hComboCapture2
                    invoke SendMessage, hWndCap2, WM_CAP_DRIVER_DISCONNECT, 0, 0
                    invoke SendMessage, hComboCapture2, CB_GETCURSEL, ADDR dwnewindex, 0
                    .if eax == 0
                        invoke SendMessage, hWndCap2, WM_CAP_DRIVER_DISCONNECT, 0, 0
                        xor eax,eax
                        ret
                    .endif
                    dec eax
                    invoke SendMessage, hWndCap2, WM_CAP_DRIVER_CONNECT, eax, 0
                    invoke SendMessage, hWndCap2, WM_CAP_SET_PREVIEWRATE, 1000, 0
                    invoke SendMessage, hWndCap2, WM_CAP_SET_SCALE, TRUE, 0
                    invoke SendMessage, hWndCap2, WM_CAP_SET_PREVIEW, TRUE, 0
                    
                .elseif eax == hComboCapture3
                    invoke SendMessage, hWndCap3, WM_CAP_DRIVER_DISCONNECT, 0, 0
                    invoke SendMessage, hComboCapture3, CB_GETCURSEL, ADDR dwnewindex, 0
                    .if eax == 0
                        invoke SendMessage, hWndCap3, WM_CAP_DRIVER_DISCONNECT, 0, 0
                        xor eax,eax
                        ret
                    .endif
                    dec eax
                    invoke SendMessage, hWndCap3, WM_CAP_DRIVER_CONNECT, eax, 0
                    invoke SendMessage, hWndCap3, WM_CAP_SET_PREVIEWRATE, 1000, 0
                    invoke SendMessage, hWndCap3, WM_CAP_SET_SCALE, TRUE, 0
                    invoke SendMessage, hWndCap3, WM_CAP_SET_PREVIEW, TRUE, 0
                .endif

        .elseif ax==142     ; Webcam #1 Adjust

            .if hWndCap1 != NULL

                invoke SendMessage, hWndCap1, WM_CAP_DRIVER_GET_CAPS, sizeof CapDrvCaps, ADDR CapDrvCaps
                ; Video source dialog box. 
                .if (CapDrvCaps.fHasDlgVideoSource)
                    invoke SendMessage, hWndCap1, WM_CAP_DLG_VIDEOSOURCE, 0, 0
                .endif
                ; Video format dialog box. 
                .if (CapDrvCaps.fHasDlgVideoFormat)
                    invoke SendMessage, hWndCap1, WM_CAP_DLG_VIDEOFORMAT, 0, 0
                .endif
                ; Video display dialog box. 
                .if (CapDrvCaps.fHasDlgVideoDisplay)
                    invoke SendMessage, hWndCap1, WM_CAP_DLG_VIDEODISPLAY, 0, 0
                .endif

            .endif

        .elseif ax==180     ; Webcam #2 Adjust

            .if hWndCap2 != NULL

                invoke SendMessage, hWndCap2, WM_CAP_DRIVER_GET_CAPS, sizeof CapDrvCaps, ADDR CapDrvCaps
                ; Video source dialog box. 
                .if (CapDrvCaps.fHasDlgVideoSource)
                    invoke SendMessage, hWndCap2, WM_CAP_DLG_VIDEOSOURCE, 0, 0
                .endif
                ; Video format dialog box. 
                .if (CapDrvCaps.fHasDlgVideoFormat)
                    invoke SendMessage, hWndCap2, WM_CAP_DLG_VIDEOFORMAT, 0, 0
                .endif
                ; Video display dialog box. 
                .if (CapDrvCaps.fHasDlgVideoDisplay)
                    invoke SendMessage, hWndCap2, WM_CAP_DLG_VIDEODISPLAY, 0, 0
                .endif

            .endif

        .elseif ax==185     ; Webcam #3 Adjust

            .if hWndCap3 != NULL

                invoke SendMessage, hWndCap3, WM_CAP_DRIVER_GET_CAPS, sizeof CapDrvCaps, ADDR CapDrvCaps
                ; Video source dialog box. 
                .if (CapDrvCaps.fHasDlgVideoSource)
                    invoke SendMessage, hWndCap3, WM_CAP_DLG_VIDEOSOURCE, 0, 0
                .endif
                ; Video format dialog box. 
                .if (CapDrvCaps.fHasDlgVideoFormat)
                    invoke SendMessage, hWndCap3, WM_CAP_DLG_VIDEOFORMAT, 0, 0
                .endif
                ; Video display dialog box. 
                .if (CapDrvCaps.fHasDlgVideoDisplay)
                    invoke SendMessage, hWndCap3, WM_CAP_DLG_VIDEODISPLAY, 0, 0
                .endif

            .endif

        .elseif ax==143     ; Webcam #1 Save
        
            .if hWndCap1 != NULL
                invoke prSaveImage, hWndCap1, CTEXT("webcam1.bmp")
            .endif

        .elseif ax==181     ; Webcam #2 Save
        
            .if hWndCap2 != NULL
                invoke prSaveImage, hWndCap2, CTEXT("webcam2.bmp")
            .endif

        .elseif ax==186     ; Webcam #3 Save
        
            .if hWndCap3 != NULL
                invoke prSaveImage, hWndCap3, CTEXT("webcam3.bmp")
            .endif

         .endif
    .endif
    
    xor eax,eax
    ret

 WndProc endp

prSaveImage Proc hthiscapturewindow:DWORD, lpFileName:DWORD
LOCAL hdc:HDC
LOCAL memdc:HDC
LOCAL hSaveBMFile:HANDLE
LOCAL dwBytes:DWORD
LOCAL bitmapfileheader:BITMAPFILEHEADER
LOCAL bitmapinfoheader:BITMAPINFOHEADER
LOCAL colors[256]:RGBQUAD
LOCAL bmpinfo:BITMAPINFO
LOCAL hBitmap:HBITMAP
LOCAL pBits:DWORD
LOCAL dwWidth:DWORD
LOCAL dwHeight:DWORD
LOCAL dwNumColors:DWORD
LOCAL dwBPP:DWORD
LOCAL ColorSize:DWORD
LOCAL rc:RECT
    
    invoke GetDC, hthiscapturewindow
    mov hdc,eax
    
    invoke GetWindowRect, hthiscapturewindow, ADDR rc
    mov eax, rc.right
    sub eax, rc.left
    mov dwWidth,eax
    mov eax, rc.bottom
    sub eax, rc.top
    mov dwHeight,eax
    invoke GetDeviceCaps, hdc, BITSPIXEL
    mov dwBPP,eax
    .IF (eax<=8)
        invoke GetDeviceCaps, hdc, NUMCOLORS
        mov dwNumColors,eax
        mov dwNumColors,256	;this one looks bad
    .ELSE
        mov dwNumColors,0
    .ENDIF
    invoke CreateCompatibleDC, hdc
    mov memdc,eax
    .IF (eax==NULL)
        invoke DeleteDC, hdc
        jmp @ExitFunc
    .ENDIF
    mov bmpinfo.bmiHeader.biSize,sizeof BITMAPINFOHEADER
    mov eax,dwWidth
    mov bmpinfo.bmiHeader.biWidth,eax
    mov eax,dwHeight
    mov bmpinfo.bmiHeader.biHeight,eax
    mov bmpinfo.bmiHeader.biPlanes,1
    mov ax,word ptr [dwBPP]
    mov bmpinfo.bmiHeader.biBitCount,ax
    mov bmpinfo.bmiHeader.biCompression,BI_RGB
    mov bmpinfo.bmiHeader.biSizeImage,0
    mov bmpinfo.bmiHeader.biXPelsPerMeter,0
    mov bmpinfo.bmiHeader.biYPelsPerMeter,0
    mov eax,dwNumColors
    mov bmpinfo.bmiHeader.biClrUsed,eax
    mov bmpinfo.bmiHeader.biClrImportant,eax
    invoke CreateDIBSection,hdc,addr bmpinfo, DIB_PAL_COLORS,addr pBits, NULL, 0
    mov hBitmap,eax
    .IF (eax==NULL)
        invoke DeleteDC, hdc
        invoke DeleteDC, memdc
        jmp @ExitFunc
    .ENDIF
    invoke SelectObject, memdc, hBitmap
    .IF (eax==NULL) || (eax==GDI_ERROR)
        invoke DeleteDC, hdc
        invoke DeleteDC, memdc
        jmp @ExitFunc
    .ENDIF
    invoke BitBlt, memdc, 0,0, dwWidth, dwHeight, hdc, 0,0, SRCCOPY
    .IF (!eax)
        invoke DeleteDC, hdc
        invoke DeleteDC, memdc
        jmp @ExitFunc
    .ENDIF
    mov eax,dwNumColors
    .IF (eax!=0)
        invoke GetDIBColorTable, memdc, 0, dwNumColors, addr colors
        mov dwNumColors,eax
    .ENDIF
    mov bitmapfileheader.bfType,4D42h
    mov eax,dwNumColors
    xor edx,edx
    mov ecx,sizeof RGBQUAD
    mul ecx
    mov ColorSize,eax
    mov eax,dwWidth
    xor edx,edx
    mov ecx,dwHeight
    mul ecx
    xor edx,edx
    mov ecx,dwBPP
    mul ecx
    shr eax,3
    add eax,ColorSize
    add eax,sizeof BITMAPFILEHEADER
    add eax,sizeof BITMAPINFOHEADER
    mov bitmapfileheader.bfSize,eax
    mov bitmapfileheader.bfReserved1,0
    mov bitmapfileheader.bfReserved2,0
    mov eax,ColorSize
    add eax,sizeof BITMAPFILEHEADER
    add eax,sizeof BITMAPINFOHEADER
    mov bitmapfileheader.bfOffBits,eax
    mov bitmapinfoheader.biSize,sizeof BITMAPINFOHEADER
    mov eax,dwWidth
    mov bitmapinfoheader.biWidth,eax
    mov eax,dwHeight
    mov bitmapinfoheader.biHeight,eax
    mov bitmapinfoheader.biPlanes,1
    mov ax,word ptr [dwBPP]
    mov bitmapinfoheader.biBitCount,ax
    mov bitmapinfoheader.biCompression,BI_RGB
    mov bitmapinfoheader.biSizeImage,0
    mov bitmapinfoheader.biXPelsPerMeter,0
    mov bitmapinfoheader.biYPelsPerMeter,0
    mov eax,dwNumColors
    mov bitmapinfoheader.biClrUsed,eax
    mov bitmapinfoheader.biClrImportant,0
    invoke CreateFile, lpFileName,GENERIC_WRITE,0,\
    NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
    mov hSaveBMFile,eax
    .IF (eax==INVALID_HANDLE_VALUE)
        invoke DeleteObject, hBitmap
        invoke DeleteDC, memdc
        invoke DeleteDC, hdc
        jmp @ExitFunc
    .ENDIF
    invoke WriteFile, hSaveBMFile, addr bitmapfileheader, sizeof BITMAPFILEHEADER,\
    addr dwBytes, NULL
    invoke WriteFile, hSaveBMFile, addr bitmapinfoheader, sizeof BITMAPINFOHEADER,\
    addr dwBytes, NULL
    mov eax,dwNumColors
    .IF (eax!=0)
        invoke WriteFile, hSaveBMFile, addr colors, ColorSize, addr dwBytes,NULL
    .ENDIF
    mov eax,dwWidth
    xor edx,edx
    mov ecx,dwHeight
    mul ecx
    xor edx,edx
    mov ecx,dwBPP
    mul ecx
    shr eax,3
    mov ColorSize,eax
    invoke WriteFile, hSaveBMFile, pBits, ColorSize, addr dwBytes,NULL
    invoke CloseHandle, hSaveBMFile
    invoke DeleteObject ,hBitmap
    invoke DeleteDC, memdc
    invoke DeleteDC, hdc

@ExitFunc:
    ret

prSaveImage endp



end start